%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                 PSG Type    PSG Object                       Location in Problem Statement                                                                     Class
%matrix_xfirst_stormg2_data             data        matrix_xfirst_stormg2            avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    double
%matrix_xfirst_stormg2_vars             vars        matrix_xfirst_stormg2            avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    cell
%matrix_xmulti_stormg2_benchmark        bench       matrix_xmulti_stormg2            linearmulti(matrix_xmulti_stormg2)                                                                double
%matrix_xmulti_stormg2_data             data        matrix_xmulti_stormg2            linearmulti(matrix_xmulti_stormg2)                                                                double
%matrix_xmulti_stormg2_vars             vars        matrix_xmulti_stormg2            linearmulti(matrix_xmulti_stormg2)                                                                cell
%matrix_subproblem_stormg2_benchmark    bench       matrix_subproblem_stormg2        avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    double
%matrix_subproblem_stormg2_data         data        matrix_subproblem_stormg2        avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    double
%matrix_subproblem_stormg2_vars         vars        matrix_subproblem_stormg2        avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    cell
%matrix_of_scenarios_stormg2_8_data     data        matrix_of_scenarios_stormg2_8    avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    double
%matrix_of_scenarios_stormg2_8_vars     vars        matrix_of_scenarios_stormg2_8    avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))    cell
%vector_l_stormg2_data                  data        vector_l_stormg2                 Constraint: >= vector_l_stormg2, <= vector_u_stormg2                                              double
%vector_u_stormg2_data                  data        vector_u_stormg2                 Constraint: >= vector_l_stormg2, <= vector_u_stormg2                                              double
%parameter_bound_data                   data        parameter_bound                  Box: >= parameter_bound, <= parameter_bound_1                                                     double
%parameter_bound_1_data                 data        parameter_bound_1                Box: >= parameter_bound, <= parameter_bound_1                                                     double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_xfirst_stormg2_data,matrix_xfirst_stormg2_vars,matrix_xmulti_stormg2_benchmark,matrix_xmulti_stormg2_data,matrix_xmulti_stormg2_vars,matrix_subproblem_stormg2_benchmark,matrix_subproblem_stormg2_data,matrix_subproblem_stormg2_vars,matrix_of_scenarios_stormg2_8_data,matrix_of_scenarios_stormg2_8_vars,vector_l_stormg2_data,vector_u_stormg2_data,parameter_bound_data,parameter_bound_1_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_xfirst_stormg2',matrix_xfirst_stormg2_data,matrix_xfirst_stormg2_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_xmulti_stormg2',matrix_xmulti_stormg2_data,matrix_xmulti_stormg2_vars,matrix_xmulti_stormg2_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_subproblem_stormg2',matrix_subproblem_stormg2_data,matrix_subproblem_stormg2_vars,matrix_subproblem_stormg2_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_of_scenarios_stormg2_8',matrix_of_scenarios_stormg2_8_data,matrix_of_scenarios_stormg2_8_vars,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_l_stormg2',vector_l_stormg2_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_u_stormg2',vector_u_stormg2_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  avg(recourse(matrix_xfirst_stormg2, matrix_subproblem_stormg2, matrix_of_scenarios_stormg2_8))',...
'Constraint: >= vector_l_stormg2, <= vector_u_stormg2',...
'  linearmulti(matrix_xmulti_stormg2)',...
'Box: >= parameter_bound, <= parameter_bound_1',...
'',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

